<template>
  <div v-if="isVisible">
    <IdGrafico id="005" />
    <v-card
      :loading="isLoadingCumplimientoDisciplinaPorNegocio"
      tile
      raised
      elevation="3"
    >
      <div></div>
      <div class="title-card-component">
        Cumplimiento de la disciplina por negocio
        <span
          v-if="
            globalFilters && globalFilters.filters.nivel_geografico.descripcion
          "
          class="bold keep-spaces"
          >{{ " " + globalFilters.filters.nivel_geografico.descripcion }}</span
        >
      </div>
      <div class="contenido">
        <div style="float:right">
          <v-radio-group v-model="isPersentValue">
            <v-radio
              color="primary"
              label="Porcentaje (%)"
              :value="true"
            ></v-radio>
            <v-radio
              color="primary"
              label="Puntos de contacto"
              :value="false"
            ></v-radio>
          </v-radio-group>
        </div>
        <div
          class="contenedorBarra"
          v-for="(itemNegocioDisciplina,
          indexItemNegocioDisciplina) in negociosDisciplina.negocios"
          :key="indexItemNegocioDisciplina"
        >
          <div>
            <v-img
              :contain="true"
              :aspect-ratio="1"
              position="center"
              class="segundaSeccionImg"
              :src="itemNegocioDisciplina.logo_image"
              :lazy-src="itemNegocioDisciplina.logo_image"
            />
            <div class="barra tBold">
              <template
                v-for="(itemRangoNegocio,
                indexItemRangoNegocio) in itemNegocioDisciplina.rangos"
              >
                <div
                  :key="indexItemRangoNegocio"
                  v-bind:style="{
                    width: itemRangoNegocio.width + '%',
                    backgroundColor: itemRangoNegocio.rango.detalle
                  }"
                  class="text-center"
                >
                  <template v-if="isPersentValue">
                    {{ itemRangoNegocio.calificacion }}%
                  </template>
                  <template v-else>
                    {{ itemRangoNegocio.puntos_contacto }}
                  </template>
                </div>
              </template>
            </div>
          </div>
          <div class="infoGrafica">
            <span class="bold" style="margin-right:3px;"
              >{{ itemNegocioDisciplina.total_evaluados }} Puntos de
              Contacto</span
            >
            evaluados para el Negocio
            {{
              getNegocioById(itemNegocioDisciplina.id_negocio)
                .negocio_disciplina_franquicia
            }}
          </div>
        </div>
      </div>
      <div class="footerGrafica2">
        <div>
          <img
            src="~@/assets/img/company.svg"
            width="15px"
            style="margin-right: 5px;margin-top: 3px;"
          />
          <span class="bold">
            {{ negociosDisciplina.total_evaluados }} Puntos de Contacto</span
          >
          correspondiente al nivel
          <span
            v-if="
              globalFilters &&
                globalFilters.filters.nivel_geografico.descripcion
            "
            class="bold keep-spaces"
            >{{
              " " + globalFilters.filters.nivel_geografico.descripcion
            }}</span
          >
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
.keep-spaces {
  white-space: pre-wrap;
}
.title-card-component {
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: #1e2945;
  color: white;
  padding: 5px 0px;
}
.contenido {
  min-height: 195px;
  padding: 15px;
  border-bottom: unset;
}
.contenedorBarra > div:nth-child(1) {
  display: flex;
  width: 100%;
  align-items: center;
}
.contenedorBarra > div:nth-child(2) {
  display: flex;
  width: 100%;
  align-items: center;
}
.segundaSeccionImg {
  width: 40px;
  margin: 0px 15px 0px 6px;
}
.barra {
  width: 100%;
  display: flex;
  color: white;
  background-color: grey;
}
.barra > div {
  height: 23px;
  display: flex;
  align-items: center;
  padding-left: 6px;
  justify-content: center;
}
.infoGrafica {
  padding: 5px 0px 5px 60px;
  font-size: 12px;
  color: #969696;
}
.footerGrafica2 {
  width: 100%;
  background-color: #e5e5e5;
  border-top: unset;
  padding: 3px 20px;
}
</style>
<script>
import store from "@/store";
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-CumplimientoDisciplinaPorNegocio",
  components: {
    IdGrafico
  },
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  data() {
    return {
      isPersentValue: true,
      isLoadingCumplimientoDisciplinaPorNegocio: true,
      methodsSemaforo: null,
      negociosDisciplina: {},
      globalFilters: null,
      isVisible: null,
      metadata: {
        negocios: null
      }
    };
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      if (globalFilters.final_filters.nivel_geografico > 0) {
        this.isVisible = true;
        this.globalFilters = globalFilters;
        this.getCumplimientoDisciplinaNegocio();
      } else {
        this.isVisible = false;
      }
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getNegocioById(idNegocio) {
      if (this.metadata.negocios) {
        const negocio = this.metadata.negocios.filter(
          (itemNegocio) => itemNegocio.id_negocio_franquicia == idNegocio
        )[0];
        if (negocio) {
          return negocio;
        }
      }
      return {};
    },
    getCumplimientoDisciplinaNegocio() {
      this.isLoadingCumplimientoDisciplinaPorNegocio = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/cumplimiento/disciplina/negocio/nivel",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCumplimientoDisciplinaNegocio(data);
              }
            } else {
              self.setCumplimientoDisciplinaNegocio([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCumplimientoDisciplinaPorNegocio = false;
        });
    },
    setCumplimientoDisciplinaNegocio(negociosDisciplina) {
      negociosDisciplina.negocios.forEach((itemNegocio) => {
        let sumRango = 0;
        itemNegocio.logo_image = serviceCommons.getLogoImageByIdNegocio(
          itemNegocio.id_negocio
        );
        itemNegocio.rangos.forEach((itemRango) => {
          sumRango += itemRango.calificacion;
          itemRango.width = itemRango.calificacion;
          if (
            this.methodsSemaforo &&
            this.methodsSemaforo.getRangoById(itemRango.id_rango)
          ) {
            let rango = this.methodsSemaforo.getRangoById(itemRango.id_rango);
            itemRango.rango = {
              detalle: rango.detalle
            };
          } else {
            itemRango.rango = {
              detalle: ""
            };
          }
          if (sumRango < 100) {
            let rango = itemNegocio.rangos.reduce(function(prev, current) {
              return prev.calificacion < current.calificacion ? prev : current;
            });
            rango.width = 100 - sumRango + rango.calificacion;
          }
        });
      });
      this.negociosDisciplina = negociosDisciplina;
    },
    getNegocios() {
      const self = this;
      axios
        .get("franquicia/negocio/disciplina/secure/get")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setNegocios(data);
              }
            } else {
              self.setNegocios([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setNegocios(negocios) {
      this.metadata.negocios = negocios;
    }
  },
  mounted() {
    this.getNegocios();
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters) {
      this.getCumplimientoDisciplinaNegocio();
    }
  }
};
</script>
